#include "position.h"
#include "ezwin.h"
#include "bitmap.h"
#include<assert.h>
#include "Generate.h"
#include<string>
#include<sstream>

SimpleWindow w1("Sudoku Mania",14.0,12.0,Position(5.0,1.0));

BitMap Bmp1(w1);
BitMap Bmp2(w1);
BitMap Bmp3(w1);
BitMap Bmp4(w1);

//Need for remembering the status of each bitmap

enum BmpStatus{Drawn,Erased};
BmpStatus Bmp1Status=Erased;
BmpStatus Bmp2Status=Erased;
BmpStatus Bmp3Status=Erased;
BmpStatus Bmp4Status=Erased;



Position Centre;
Position BmpCorner;

Position Upperleft;
Position Lowerleft;
Position VarSqre;

Position CentreUpperleftSqre;
Position CentreLowerleftSqre;

double CentreX;
double CentreY;

double CursorX;
double CursorY;
int t;
int value;
int level;
int m;
int n;

string conversion;
stringstream ss;

Sudoku Solved,Grid1,Grid2;

Position ChangeVarSquare(int x,int y)//REturns a position type after receiving two parameters
{                                     //The position in the sudoku grid is calculated according to the array indices passed
    Position v=CentreUpperleftSqre +Position(1*x,1*y);
    Upperleft = v + Position(-0.4,-0.4);
    Lowerleft = v + Position(0.4,0.4);
    return v;
}

Position ChangeLowerVarSqre(int x)//Returns a position type after receving a parameter
                                //The position in the input box is calculated according to the  indices passed
{
    Position v= CentreLowerleftSqre + Position(x*0.65,0);
    return v;
}

int DisplaySudoku()	//Displays the internally generated sudoku  for playing in the window at the beginning of the game
{
       for(m=0;m<9;m++)
       {
           for(n=0;n<9;n++)
           {
               VarSqre =ChangeVarSquare(m,n);
               if(Grid1.puzzle[m][n]!=0)
               {
                   char c=Grid1.puzzle[m][n] + 48;


                   char C[2];
                   C[0]=c;
                   C[1]='\0';
                   w1.RenderText(Upperleft,Lowerleft,C,Magenta,White);
               }
           }
       }
       return 0;
}
/*The return type integer function which is the parameter of  predefined function "SetMouseClickCallback" of simple window class
It returns 1 on a sucessful mouse click and zero otherwise.It notes the position of the mouse click and judges what is to be done according to
position of the click with respect to the bitmap appearing in the window.We have taken some enum variable which remebers whether a bitmap is
drawn in the window or it is erased and other is drawn.All the enum objects carrying the bitmap status are initially initialised to zero
except the first bitmap which represents the main menu window.According to the click position it decides whether to call the next bitmap.In this
case it  initialises the first bitmapstatus to erased and erases it and sets the called bitmap status to drawn and draws it without changing the
window in other words all the bitmaps are linked with the same window.

*/
int Mouse(const Position &p)
{
    CursorX=p.GetXDistance();
    CursorY=p.GetYDistance();

    if(Bmp1Status==Drawn)
    {
        if(CursorX>=(CentreX-2.1)&&CursorX<=(CentreX+2.5))
        {
            if(CursorY>=(CentreY-2.8)&&CursorY<=(CentreY-1.2))
            {
                Bmp2Status=Drawn;
                Bmp1Status=Erased;                          //The button for New Game
                Bmp2.SetPosition(BmpCorner);
                Bmp1.Erase();
                Bmp2.Draw();
                return 1;
            }
            else if(CursorY>=(CentreY)&&CursorY<=(CentreY+1.5))
            {
                Bmp1Status=Erased;
                Bmp1.Erase();
                w1.Close();                                 //The buttin Quit
                return 0;
            }
        }
    }

	if(Bmp2Status==Drawn)
	{
		if((CursorX>=CentreX-2.1) && (CursorX<=CentreX+2.5))
		{
			if ((CursorY>=CentreY-2.8) && (CursorY<=CentreY-1.2))      // for easy button
 			{
 				level=81-(23+rand()%2);
 				VarSqre=ChangeLowerVarSqre(2);
 				Upperleft = VarSqre + Position(-3,-1);
   				Lowerleft = VarSqre + Position(3,1);
 				Grid1.generate(Solved,Grid1,level);
				Grid1.equal_array(Grid2,Grid1);
				Bmp2.Erase();
				Bmp2Status=Erased;
				Bmp3.SetPosition(BmpCorner);
				Bmp3.Draw();
				Bmp3Status=Drawn;
				DisplaySudoku();
				return 1;
			}


			if ((CursorY>=CentreY-0.8) && (CursorY<=CentreY+0.8))      // for medium button
	 		{
	 			level=81-(25+rand()%3);
	 			Grid1.generate(Solved,Grid1,level);
 				Grid1.equal_array(Grid2,Grid1);
				Bmp2.Erase();
				Bmp2Status=Erased;
				Bmp3.SetPosition(BmpCorner);
				Bmp3.Draw();
				Bmp3Status=Drawn;
				DisplaySudoku();
				return 1;
			}


			if ((CursorY>=CentreY+1.2) && (CursorY<=CentreY+2.9))      // For hard button
 			{
 				level=81-(28+rand()%3);
 				Grid1.generate(Solved,Grid1,level);
 				Grid1.equal_array(Grid2,Grid1);
				Bmp2.Erase();
				Bmp2Status=Erased;
				Bmp3.SetPosition(BmpCorner);
				Bmp3.Draw();
				Bmp3Status=Drawn;
				DisplaySudoku();
				return 1;
			}
			return 1;

		}
	}


    if(Bmp3Status==Drawn)
    {


       if((CursorX>=CentreX-4.5) && (CursorX<=CentreX-2.9))
	{
		if((CursorY>=CentreY-4) &&(CursorY<=CentreY-2.4))// verify button
		{
			if(Grid1.check_equal(Solved,Grid2))
			{
				w1.Message("You solved Correctly");
			}
			else
			{
				w1.Message("You solved Incorrectly");
			}
		}

		if((CursorY>=CentreY-0.8) &&(CursorY<=CentreY+0.8))// solved button
		{
			Bmp3.Erase();
			Bmp3Status=Erased;
			Bmp4.SetPosition(BmpCorner);
			Bmp4.Draw();
			Bmp4Status=Drawn;
			 for(m=0;m<9;m++)
        		{
            			for(n=0;n<9;n++)
            			{
                			VarSqre = ChangeVarSquare(m,n);
               				char c=Solved.puzzle[m][n]+48;
                			//ss<<c;
                			//ss>>conversion;
                			char C[2];
                			C[0]=c;
                			C[1]='\0';
                			if(Grid1.puzzle[m][n]!=0)
                			{
                   				 w1.RenderText(Upperleft,Lowerleft,C,Magenta,White);
                			}
                			else
                			{
                    				w1.RenderText(Upperleft,Lowerleft,C,Black,White);
               				}
            			}
        		}
			return 1;
		}
		if((CursorY>=CentreY+2.4) &&(CursorY<=CentreY+4)) // Main Menu button
		{
			Bmp3.Erase();
			Bmp3Status=Erased;
			Bmp1.SetPosition(BmpCorner);
			Bmp1.Draw();
			Bmp1Status=Drawn;
			return 1;
		}
	}



       for(t=0;t<9;t++)
       {
           VarSqre = ChangeLowerVarSqre(t);
           if(CursorX>=(VarSqre.GetXDistance()-0.28)&&CursorX<=(VarSqre.GetXDistance() +0.28))
           {
               if(CursorY>=(VarSqre.GetYDistance()-0.27)&&CursorY<=(VarSqre.GetYDistance() +0.27))
               {
                   value = t + 1;
                   return 1;
               }
           }
       }

       for(m=0;m<9;m++)
       {
           for(n=0;n<9;n++)
           {
               VarSqre =ChangeVarSquare(m,n);
               if(CursorX>=(VarSqre.GetXDistance()-0.77)&&CursorX<=(VarSqre.GetXDistance()+0.77))
               {
                   if(CursorY>=(VarSqre.GetYDistance()-0.77)&&CursorY<=(VarSqre.GetYDistance()+0.77))
                   {
                       if(Grid1.puzzle[m][n]!=0)
                       {
                           return 1;
                       }
                       Grid2.puzzle[m][n]=value;
                       char c=value + 48;
                       //ss<<c;
                       //s>>conversion;
                       char C[2];
                       C[0]=c;
                       C[1]='\0';
                       w1.RenderText(Upperleft,Lowerleft,C,Black,White);
                       return 1;
                   }
               }
           }
       }
    }

    if(Bmp4Status==Drawn)
    {


        if(CursorX>=(CentreX - 4.5)&&CursorX<=(CentreX-2.9))
        {
            if(CursorY>=(CentreY+2.4)&&CursorY<=(CentreY+4))
            {
                Bmp4Status=Erased;
                Bmp1.SetPosition(BmpCorner);
                Bmp1Status=Drawn;
                Bmp4.Erase();
                Bmp1.Draw();
                return 1;
            }
        }
    }
    return 1;
}

int ApiMain()
{
	w1.Open();
	//assert(w1.GetStatus() == WindowOpen);
	Centre = w1.GetCenter() + Position(0,-0.5);
	BmpCorner = Centre + Position(-5.0,-4.0);

	CentreUpperleftSqre = Centre + Position(-2,-3.55);
	CentreLowerleftSqre = Centre + Position(-2.1,5.7);

	CentreX = Centre.GetXDistance();
	CentreY = Centre.GetYDistance();

	Bmp1.Load("1.xpm");
	assert(Bmp1.GetStatus()==BitMapOkay);
	Bmp2.Load("2.xpm");
	//assert(Bmp2.GetStatus()==BitMapOkay);
	Bmp3.Load("3.xpm");
	//assert(Bmp3.GetStatus()==BitMapOkay);
	Bmp4.Load("4.xpm");
	//assert(Bmp4.GetStatus()==BitMapOkay);

	Bmp1.SetPosition(BmpCorner);
	Bmp1.Draw();
	Bmp1Status=Drawn;
	w1.SetMouseClickCallback(Mouse);



	return 0;
}
